%define rel 3

%define svn 0

%if %{svn}
%define rev 95
%endif

%define upname firetray

%define ft_guid \{9533f794-00b4-4354-aa15-c2bbda6989f8\}

%define ff_guid \{ec8030f7-c20a-464f-9b0e-13a3a9e97384\}
%define tb_guid \{3550f703-e582-4d05-9a08-453d09bdfdc6\}
%define sm_guid \{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a\}
%define sb_guid \{718e30fb-e89b-41dd-9da7-e25a45638b28\}
%define cz_guid \{59c81df5-4b7a-477b-912d-4e0fdf64e5f2\}

%define mz_ext_dir %{_libdir}/mozilla/extensions/

Name:           mozilla-firetray
Version:        0.2.8
%if %{svn}
Release:        %{?pre}%{rel}.%{rev}svn%{?dist}
%else
Release:        %{rel}%{?dist}  
%endif      
Summary:        A system tray addon for mozilla

Group:          User Interface/X
License:        GPLv2 and CC-BY-SA
URL:            http://code.google.com/p/firetray
%if %{svn}
# This is an svn snapshot, to get this tarball, use :
# svn checkout -r %%{rev} http://firetray.googlecode.com/svn/trunk/ firetray-read-only
# rm -rf `find firetray-read-only -name '.svn'`
# mv firetray-read-only %%{upname}-%%{version}-%%{rev}svn
# tar cjf %%{upname}-%%{version}-%%{rev}svn.tar.bz2 %%{upname}-%%{version}-%%{rev}svn         
Source0:        %{upname}-%{version}-%{rev}svn.tar.bz2
%else
Source0:        http://%{upname}.googlecode.com/files/%{upname}-%{version}-src.zip
%endif
BuildRoot:      %{_tmppath}/%{upname}-%{version}-%{release}-root-%(%{__id_u} -n)

# Patch0 : use nspr include path from pkg-config istead of a hardcoded one
#          http://code.google.com/p/firetray/issues/detail?id=128
Patch0:         %{name}-%{version}-fix-nspr-include.patch
# Patch1:  fix wrong unread mail count in thunderbird and seamonkey
#          http://code.google.com/p/firetray/issues/detail?id=120
Patch1:         %{name}-%{version}-fix-unread-mail-count.patch
# Patch2 : use the system's CXXFLAGS, fix backported from upstream's vcs
#          https://bugzilla.redhat.com/show_bug.cgi?id=621683
Patch2:    %{name}-%{version}-use-system-cxxflags.patch
# Patch3 : use our own icons instead of the provided ones, except the newmail one
#          http://code.google.com/p/firetray/issues/detail?id=109
Patch3:         %{name}-%{version}-use-our-icons.patch
# Patch8 : add support for chatzilla
Patch8:         %{name}-%{version}-add-chatzilla-support.patch


BuildRequires:  xulrunner-devel
%if %{fedora} <= 12
BuildRequires:  xulrunner-devel-unstable
%endif
BuildRequires:  scons
BuildRequires:  zip unzip

%description
Firetray is a system tray addon for mozilla, current features are :

- adds tray icon for both firefox and thunderbird
- Show number of unread mails in the tray icon (Thunderbird)
- close button hides to tray
- ability to start minimized to tray
- when restoring if the window is iconified, deiconify it
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

%package core
Summary:        Core files for Mozilla Firetray Extension

%description core

Firetray is a system tray addon for mozilla, current features are :

- adds tray icon for both firefox and thunderbird
- Show number of unread mails in the tray icon (Thunderbird)
- close button hides to tray
- ability to start minimized to tray
- when restoring if the window is iconified, deiconify it
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

This package contains the files needed for all mozilla products
to use the Firetray extension.

%package firefox
Summary:        System tray extension for firefox
Requires:       firefox 
Requires:       %{name}-core = %{version}

%description firefox
Firetray is a system tray addon for firefox, current features are :

- adds tray icon
- close button hides to tray
- ability to start minimized to tray
- when restoring if the window is iconified, deiconify it
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

%package thunderbird
Summary:        System tray extension for thunderbird
Requires:       thunderbird 
Requires:       %{name}-core = %{version}

%description thunderbird
Firetray is a system tray addon for thunderbird, current features are :

- adds tray icon
- Show number of unread mails in the tray icon
- close button hides to tray
- ability to start minimized to tray
- when restoring if the window is iconified, deiconify it
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

%package seamonkey
Summary:        System tray extension for seamonkey
Requires:       seamonkey 
Requires:       %{name}-core = %{version}

%description seamonkey
Firetray is a system tray addon for seamonkey, current features are :

- adds tray icon
- Show number of unread mails in the tray icon
- close button hides to tray
- ability to start minimized to tray
- when restoring if the window is iconified, deiconify it
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

%package sunbird
Summary:        System tray extension for sunbird
Requires:       sunbird 
Requires:       %{name}-core = %{version}

%description sunbird
Firetray is a system tray addon for sunbird, current features are :

- adds tray icon
- close button hides to tray
- ability to start minimized to tray
- when restoring if the window is iconified, deiconify it
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

%package chatzilla
Summary:        System tray extension for chatzilla
Requires:       chatzilla
Requires:       %{name}-core = %{version}

%description chatzilla
Firetray is a system tray addon for chatzilla, current features are :

- adds tray icon
- close button hides to tray
- ability to start minimized to tray
- when restoring if the window is iconified, deiconify it
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

%prep
%if %{svn}
%setup -q -n %{upname}-%{version}-%{rev}svn
%else
%setup -q -c %{upname}-%{version}
%endif

%patch0 -p1 -b .fix-nspr-include
%patch1 -p1 -b .fix-unread-mail-count
%patch2 -p1 -b .use-system-cxxflags
%patch3 -p1 -b .use-our-icons
%patch8 -p1 -b .add-chatzilla-support

# Make sure we don't ship prebuilt stuff
find . \( -name '*.xpi' -o -name '*.jar' -o -name '*.xpt' -o -name '*.so' \) -exec rm -f '{}' \;

# Remove existing pixmaps except the newmail one
mv components/pixmaps/newmail.xpm .
rm -rf components/pixmaps


%build
export GECKO_SDK=$(pkg-config libxul --variable=sdkdir)
export DYNAMIC_LINKING="dyn"
export CXXFLAGS="%{optflags}"
scons %{upname}.xpi

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{mz_ext_dir}{%{ff_guid},%{tb_guid},%{sm_guid},%{sb_guid},%{cz_guid}}/%{ft_guid}/components
mkdir -p $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}

unzip %{upname}.xpi -d $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}

# rename changes file to ChangeLog
mv changes ChangeLog

#create symlinks to the ChangeLog in core package and to the License in base folder
mkdir symdoc
ln -s %{_libdir}/%{name}-%{version}/License.txt symdoc/COPYING
ln -s %{_datadir}/doc/%{name}-core-%{version}/ChangeLog symdoc/ChangeLog

#now symlink the products extension's directories to the core extension directory

for i in {%{ff_guid},%{tb_guid},%{sm_guid},%{sb_guid},%{cz_guid}};do
  pushd $RPM_BUILD_ROOT%{mz_ext_dir}$i/%{ft_guid}
    for j in {install.rdf,chrome.manifest,chrome,defaults};do
      ln -s %{_libdir}/%{name}-%{version}/$j $j
    done
    for j in components/{nsMinimize.js,nsITray.xpt,nsIMinimize.xpt,libnptray.so};do
      ln -s %{_libdir}/%{name}-%{version}/$j $j
    done
  popd
done

# Install the newmail icon
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
install -Dpm 644 newmail.xpm $RPM_BUILD_ROOT%{_datadir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

# workaround for rhbz #646523
%pretrans sunbird -p <lua>
st=posix.stat("%{mz_ext_dir}%{sb_guid}/%{ft_guid}")
if st and st.type == "link" then
  os.remove("%{mz_ext_dir}%{sb_guid}/%{ft_guid}")
  posix.mkdir("%{mz_ext_dir}%{sb_guid}/%{ft_guid}")
end

%files core
%defattr(-,root,root,-)
%doc symdoc/COPYING ChangeLog
%{_libdir}/%{name}-%{version}
%{_datadir}/%{name}

%files firefox
%defattr(-,root,root,-)
%doc symdoc/COPYING symdoc/ChangeLog
%{mz_ext_dir}%{ff_guid}/%{ft_guid}

%files thunderbird
%defattr(-,root,root,-)
%doc symdoc/COPYING symdoc/ChangeLog
%{mz_ext_dir}%{tb_guid}/%{ft_guid}

%files seamonkey
%defattr(-,root,root,-)
%doc symdoc/COPYING symdoc/ChangeLog
%{mz_ext_dir}%{sm_guid}/%{ft_guid}

%files sunbird
%defattr(-,root,root,-)
%doc symdoc/COPYING symdoc/ChangeLog
%{mz_ext_dir}%{sb_guid}/%{ft_guid}

%files chatzilla
%defattr(-,root,root,-)
%doc symdoc/COPYING symdoc/ChangeLog
%{mz_ext_dir}%{cz_guid}/%{ft_guid}


%changelog
* Sun Oct 24 2010 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.2.8-3
- Symlink the extension's directory for sunbird the same way of the
  other applications using gecko >= 1.9.2, fixes rhbz #646185
- Add workaround for rhbz #646523
- Spec cleanup

* Fri Aug 05 2010 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.2.8-2
- Backport patch from upstream svn to use the system's CXXFLAGS, fixes
  rhbz #621683

* Fri Jul 16 2010 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.2.8-1
- New upstream release
- Drop some patches ( merged upstream or fixed ) :
  + mozilla-firetray-0.2.6-fix-max-versions.patch
  + mozilla-firetray-0.2.6-fix-include-path-and-cxxflags.patch
  + mozilla-firetray-0.2.6-handle-exception.patch
  + mozilla-firetray-0.2.6-fix-sunbird-chrome-path.patch
  + mozilla-firetray-0.2.6-disable-multimedia-keys.patch

* Sat May 15 2010 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.2.6-1
- Initial package
